	$modxx51
	;ukazkovy program pro LCD s radicem PCF8558
	;krystal 12MHz
SDA	equ	P3.0
SCL	equ	P3.1

init:	mov	P3,#255
	mov	P1,#255
	mov	R1,#0
	mov	dptr,#Data1

	call	Delay1
	;text
	call	I2Cstart
	mov	a,#7Ah	;adresa LCD
	call	I2Cposilej
	mov	a,#01100001b	;horizontalni, normalni mod, radek 1
	call	I2Cposilej
	mov	a,#20	;sloupec 20
	call	I2Cposilej
Loop1:	mov	a,R1
	movc	a,@a+dptr
	call	I2Cposilej
	inc	R1
	cjne	R1,#23,Loop1
	call	I2Cstop
	
	call	delay1
	;negovany mod	
	call	I2Cstart
	mov	a,#7Ah
	call	I2Cposilej
	mov	a,#00100000b	;horizontalni, neg. mod
	call	I2Cposilej
	call	I2Cstop

	call	Delay1
	;normalni mod
	call	I2Cstart
	mov	a,#7Ah
	call	I2Cposilej
	mov	a,#01100000b	;horizontalni, norm. mod
	call	I2Cposilej
	call	I2Cstop	

	call	Delay1
	;smaz displej
	call	I2Cstart
	mov	a,#7Ah
	call	I2Cposilej
	mov	a,#00000000b	;horizontalni, maz displej
	call	I2Cposilej
	call	I2Cstop
	
	call	delay1
	;rozsvit vsechny pixely
	call	I2Cstart
	mov	a,#7Ah
	call	I2Cposilej
	mov	a,#01000000b	;horizontalni, rozsvit displej
	call	I2Cposilej
	call	I2Cstop
	

	mov	dptr,#data2
	mov	R2,#50
	mov	R1,#0
	call	Delay1
	;vertikalni adresovani
	call	I2Cstart
	mov	a,#7Ah
	call	I2Cposilej
	mov	a,#01101000b	;vertikalni, norm. mod, radek 0
	call	I2Cposilej
	mov	a,#0	;sloupec 0
	call	I2Cposilej
Loop2:	mov	a,R1
	movc	a,@a+dptr
	call	I2Cposilej
	inc	R1
	cjne	R1,#10,Loop2
	mov	R1,#0
	djnz	R2,Loop2
	call	I2Cstop
	
	call	delay1
	mov	R2,#9
	mov	tmod,#00100001b
	mov	th1,#173
	setb	tr1
	setb	tr0
	;"nahodny" sum
	call	I2Cstart
	mov	a,#7Ah
	call	I2Cposilej
	mov	a,#01101000b	;vertikal, norm. mod,radek 0
	call	I2Cposilej
	mov	a,#0	;sloupec 0
	call	I2Cposilej
	;tady se generuje "nahodne" cislo
Loop3:	mov	a,tl0
	mov	b,tl1
	mul	ab
	addc	a,th0
	subb	a,tl0
	mov	c,acc.3
	mov	a,R1
	rlc	a
	mov	R1,a
	djnz	R2,Loop3
	mov	R2,#19
	mov	a,R1
	;posle "nahodny" byte
	call	I2Cposilej
	jmp	Loop3
	
	;data 1
Data1:	db	00000001b
	db	00000001b
	db	01111111b
	db	00000001b
	db	00000001b
	;
	db	00000000b
	;
	db	00111000b
	db	01010100b
	db	01010100b
	db	01010100b
	db	00001000b
	;
	db	00000000b
	;
	db	01000100b
	db	00101000b
	db	00010000b
	db	00101000b
	db	01000100b
	;
	db	00000000b
	;
	db	00000000b
	db	00001000b
	db	01111100b
	db	01001000b
	db	00000000b
	;data 2
Data2:	db	01010101b,00110011b,00001111b,00000000b,01000000b
	db	10101010b,11001100b,11110000b,11111111b,10100000b
	;zpozdeni asi 1s
Delay1:	mov	R5,#12
	mov	R6,#0
	mov	R7,#0
	djnz	R7,$
	djnz	R6,$-4
	djnz	R5,$-8
	ret
	;tu je vse se sbernici I2C
	;zpozdeni pro I2C
DelS:	nop
	nop
	ret
	;I2C start
I2CStart:	setb	SDA
	setb	SCL
	call	DelS
	clr	SDA
	call	DelS
	clr	SCL
	call	DelS
	ret
	;I2C stop
I2CStop:	setb	SCL
	call	DelS
	setb	SDA
	call	DelS
	ret
	;posilani bytu na sbernici I2C
I2CPosilej:	mov	R0,#8
Posilej1:	rlc	a
	mov	SDA,c
	call	DelS
	setb	SCL
	call	DelS
	clr	SCL
	call	DelS
	djnz	R0,Posilej1
	;do c nacti ACK
	setb	SDA
	call	DelS
	setb	SCL
	call	DelS
	mov	c,SDA
	clr	SCL
	call	DelS
	clr	SDA
	ret
	
	end	